org.springframework.batch.core

## Interface SkipListener<T,S>

- All Superinterfaces:
    StepListener
  All Known Implementing Classes:
    CompositeSkipListener, MulticasterBatchListener, SkipListenerAdapter, SkipListenerSupport, StagingItemListener, StepListenerSupport

      public interface SkipListener<T,S>
      extends StepListener

  Interface for listener to skipped items. Callbacks will be called by `Step` implementations at the appropriate time in the step lifecycle. Implementers of this interface should not assume that any method will be called immediately after an error has been encountered. Because there may be errors later on in processing the chunk, this listener will not be called until just before committing.
  Author:
    Dave Syer, Robert Kasanicky

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onSkipInProcess(T item, java.lang.Throwable t)` This item failed on processing with the given exception, and a skip was called for.
    `void` | `onSkipInRead(java.lang.Throwable t)` Callback for a failure on read that is legal, so is not going to be re-thrown.
    `void` | `onSkipInWrite(S item, java.lang.Throwable t)` This item failed on write with the given exception, and a skip was called for.

- - ### Method Detail

    - #### onSkipInRead

          void onSkipInRead(java.lang.Throwable t)

      Callback for a failure on read that is legal, so is not going to be re-thrown. In case transaction is rolled back and items are re-read, this callback will occur repeatedly for the same cause. This will only happen if read items are not buffered.
      Parameters:
        `t` - cause of the failure

    - #### onSkipInWrite

          void onSkipInWrite(S item,
                             java.lang.Throwable t)

      This item failed on write with the given exception, and a skip was called for.
      Parameters:
        `item` - the failed item
        `t` - the cause of the failure

    - #### onSkipInProcess

          void onSkipInProcess(T item,
                               java.lang.Throwable t)

      This item failed on processing with the given exception, and a skip was called for.
      Parameters:
        `item` - the failed item
        `t` - the cause of the failure